Index: trunk/Cocoa/Pester/Source/Manip.pm
===================================================================
--- trunk/Cocoa/Pester/Source/Manip.pm	(revision 617)
+++ trunk/Cocoa/Pester/Source/Manip.pm	(revision 618)
@@ -1,4 +1,4 @@
 ﻿package Date::Manip;
-# Copyright (c) 1995-2007 Sullivan Beck.  All rights reserved.
+# Copyright (c) 1995-2010 Sullivan Beck.  All rights reserved.
 # This program is free software; you can redistribute it and/or modify it
 # under the same terms as Perl itself.
@@ -6,4 +6,6 @@
 ###########################################################################
 ###########################################################################
+
+use warnings;
 
 use vars qw($OS %Lang %Holiday %Events %Curr %Cnf %Zone $VERSION @ISA @EXPORT);
@@ -37,5 +39,9 @@
 
 # Determine if we're doing taint checking
-$Date::Manip::NoTaint = eval { local $^W=0; eval("#" . substr($^X, 0, 0)); 1 };
+#if ($] < 5.0080) {
+  $Date::Manip::NoTaint = eval { local $^W=0; eval("#" . substr($^X, 0, 0)); 1 };
+#} else {
+#  $Date::Manip::NoTaint = (${^TAINT} == 0 ? 1 : 0);
+#}
 
 ###########################################################################
@@ -212,5 +218,8 @@
 use IO::File;
 
-$VERSION="5.47";
+use vars qw($Abbrevs);
+use Date::Manip::DM5abbrevs;
+
+$VERSION="5.55";
 
 ########################################################################
@@ -242,5 +251,5 @@
 no strict "vars";
 # This sorts from longest to shortest element
-sub sortByLength {
+sub _sortByLength {
   return (length $b <=> length $a);
 }
@@ -276,5 +285,5 @@
       if ($val) {
         $Curr{"InitFilesRead"}=0;
-        &EraseHolidays();
+        EraseHolidays();
       }
     } elsif ($var =~ /^PathSep$/i) {
@@ -290,5 +299,5 @@
       $Cnf{"IgnoreGlobalCnf"}=1;
     } elsif ($var =~ /^EraseHolidays$/i) {
-      &EraseHolidays();
+      EraseHolidays();
     } else {
       push(@tmp,$_);
@@ -302,6 +311,6 @@
 
     if ($Cnf{"GlobalCnf"}) {
-      $file=&ExpandTilde($Cnf{"GlobalCnf"});
-      &Date_InitFile($file)  if ($file);
+      $file=_ExpandTilde($Cnf{"GlobalCnf"});
+      _Date_InitFile($file)  if ($file);
     }
   }
@@ -312,6 +321,6 @@
 
     if ($Cnf{"PersonalCnf"}  and  $Cnf{"PersonalCnfPath"}) {
-      $file=&SearchPath($Cnf{"PersonalCnf"},$Cnf{"PersonalCnfPath"},"r");
-      &Date_InitFile($file)  if ($file);
+      $file=_SearchPath($Cnf{"PersonalCnf"},$Cnf{"PersonalCnfPath"},"r");
+      _Date_InitFile($file)  if ($file);
     }
   }
@@ -323,13 +332,13 @@
     ($var,$val)=($1,$2);
     $val=""  if (! defined $val);
-    &Date_SetConfigVariable($var,$val);
+    _Date_SetConfigVariable($var,$val);
   }
 
   confess "ERROR: Unknown FirstDay in Date::Manip.\n"
-    if (! &IsInt($Cnf{"FirstDay"},1,7));
+    if (! _IsInt($Cnf{"FirstDay"},1,7));
   confess "ERROR: Unknown WorkWeekBeg in Date::Manip.\n"
-    if (! &IsInt($Cnf{"WorkWeekBeg"},1,7));
+    if (! _IsInt($Cnf{"WorkWeekBeg"},1,7));
   confess "ERROR: Unknown WorkWeekEnd in Date::Manip.\n"
-    if (! &IsInt($Cnf{"WorkWeekEnd"},1,7));
+    if (! _IsInt($Cnf{"WorkWeekEnd"},1,7));
   confess "ERROR: Invalid WorkWeek in Date::Manip.\n"
     if ($Cnf{"WorkWeekEnd"} <= $Cnf{"WorkWeekBeg"});
@@ -338,5 +347,5 @@
      $tmp,%tmp,$tmp2,@tmp2,
      $i,$j,@tmp3,
-     $zonesrfc,@zones)=();
+     @zones)=();
 
   my($L)=$Cnf{"Language"};
@@ -346,45 +355,45 @@
 
     if ($L eq "English") {
-      &Date_Init_English(\%lang);
+      _Date_Init_English(\%lang);
 
     } elsif ($L eq "French") {
-      &Date_Init_French(\%lang);
+      _Date_Init_French(\%lang);
 
     } elsif ($L eq "Swedish") {
-      &Date_Init_Swedish(\%lang);
+      _Date_Init_Swedish(\%lang);
 
     } elsif ($L eq "German") {
-      &Date_Init_German(\%lang);
+      _Date_Init_German(\%lang);
 
     } elsif ($L eq "Polish") {
-      &Date_Init_Polish(\%lang);
+      _Date_Init_Polish(\%lang);
 
     } elsif ($L eq "Dutch"  ||
              $L eq "Nederlands") {
-      &Date_Init_Dutch(\%lang);
+      _Date_Init_Dutch(\%lang);
 
     } elsif ($L eq "Spanish") {
-      &Date_Init_Spanish(\%lang);
+      _Date_Init_Spanish(\%lang);
 
     } elsif ($L eq "Portuguese") {
-      &Date_Init_Portuguese(\%lang);
+      _Date_Init_Portuguese(\%lang);
 
     } elsif ($L eq "Romanian") {
-      &Date_Init_Romanian(\%lang);
+      _Date_Init_Romanian(\%lang);
 
     } elsif ($L eq "Italian") {
-      &Date_Init_Italian(\%lang);
+      _Date_Init_Italian(\%lang);
 
     } elsif ($L eq "Russian") {
-      &Date_Init_Russian(\%lang);
+      _Date_Init_Russian(\%lang);
 
     } elsif ($L eq "Turkish") {
-      &Date_Init_Turkish(\%lang);
+      _Date_Init_Turkish(\%lang);
 
     } elsif ($L eq "Danish") {
-      &Date_Init_Danish(\%lang);
+      _Date_Init_Danish(\%lang);
 
     } elsif ($L eq "Catalan") {
-      &Date_Init_Catalan(\%lang);
+      _Date_Init_Catalan(\%lang);
 
     } else {
@@ -401,5 +410,5 @@
     $Lang{$L}{"MonthL"}=[];
     $Lang{$L}{"MonL"}=[];
-    &Date_InitLists([$lang{"month_name"},
+    _Date_InitLists([$lang{"month_name"},
                      $lang{"month_abb"}],
                     \$Lang{$L}{"Month"},"lc,sort,back",
@@ -419,5 +428,5 @@
     $Lang{$L}{"WkL"}=[];
     $Lang{$L}{"WL"}=[];
-    &Date_InitLists([$lang{"day_name"},
+    _Date_InitLists([$lang{"day_name"},
                      $lang{"day_abb"}],
                     \$Lang{$L}{"Week"},"lc,sort,back",
@@ -425,5 +434,5 @@
                      $Lang{$L}{"WkL"}],
                     [$Lang{$L}{"WeekH"},1]);
-    &Date_InitLists([$lang{"day_char"}],
+    _Date_InitLists([$lang{"day_char"}],
                     "","lc",
                     [$Lang{$L}{"WL"}],
@@ -446,14 +455,14 @@
 
     $Lang{$L}{"LastL"}=$lang{"last"};
-    &Date_InitStrings($lang{"last"},
+    _Date_InitStrings($lang{"last"},
                       \$Lang{$L}{"Last"},"lc,sort");
 
     $Lang{$L}{"EachL"}=$lang{"each"};
-    &Date_InitStrings($lang{"each"},
+    _Date_InitStrings($lang{"each"},
                       \$Lang{$L}{"Each"},"lc,sort");
 
     $Lang{$L}{"DoMH"}={};
     $Lang{$L}{"DoML"}=[];
-    &Date_InitLists([$lang{"num_suff"},
+    _Date_InitLists([$lang{"num_suff"},
                      $lang{"num_word"}],
                     \$Lang{$L}{"DoM"},"lc,sort,back,escape",
@@ -474,5 +483,5 @@
       push(@tmp,$tmp);
     }
-    &Date_InitStrings(\@tmp,\$Lang{$L}{"WoM"},
+    _Date_InitStrings(\@tmp,\$Lang{$L}{"WoM"},
                       "lc,sort,back,escape");
 
@@ -484,7 +493,7 @@
     #   PMstr   = "PM"
 
-    &Date_InitStrings($lang{"am"},\$Lang{$L}{"AM"},"lc,sort,escape");
-    &Date_InitStrings($lang{"pm"},\$Lang{$L}{"PM"},"lc,sort,escape");
-    &Date_InitStrings([ @{$lang{"am"}},@{$lang{"pm"}} ],\$Lang{$L}{"AmPm"},
+    _Date_InitStrings($lang{"am"},\$Lang{$L}{"AM"},"lc,sort,escape");
+    _Date_InitStrings($lang{"pm"},\$Lang{$L}{"PM"},"lc,sort,escape");
+    _Date_InitStrings([ @{$lang{"am"}},@{$lang{"pm"}} ],\$Lang{$L}{"AmPm"},
                       "lc,back,sort,escape");
     $Lang{$L}{"AMstr"}=$lang{"am"}[0];
@@ -506,13 +515,13 @@
     # (so there is no confusion between Mn and Month).
 
-    &Date_InitStrings($lang{"years"}  ,\$Lang{$L}{"Yabb"}, "lc,sort");
-    &Date_InitStrings($lang{"months"} ,\$Lang{$L}{"Mabb"}, "lc,sort");
-    &Date_InitStrings($lang{"weeks"}  ,\$Lang{$L}{"Wabb"}, "lc,sort");
-    &Date_InitStrings($lang{"days"}   ,\$Lang{$L}{"Dabb"}, "lc,sort");
-    &Date_InitStrings($lang{"hours"}  ,\$Lang{$L}{"Habb"}, "lc,sort");
-    &Date_InitStrings($lang{"minutes"},\$Lang{$L}{"MNabb"},"lc,sort");
-    &Date_InitStrings($lang{"seconds"},\$Lang{$L}{"Sabb"}, "lc,sort");
+    _Date_InitStrings($lang{"years"}  ,\$Lang{$L}{"Yabb"}, "lc,sort");
+    _Date_InitStrings($lang{"months"} ,\$Lang{$L}{"Mabb"}, "lc,sort");
+    _Date_InitStrings($lang{"weeks"}  ,\$Lang{$L}{"Wabb"}, "lc,sort");
+    _Date_InitStrings($lang{"days"}   ,\$Lang{$L}{"Dabb"}, "lc,sort");
+    _Date_InitStrings($lang{"hours"}  ,\$Lang{$L}{"Habb"}, "lc,sort");
+    _Date_InitStrings($lang{"minutes"},\$Lang{$L}{"MNabb"},"lc,sort");
+    _Date_InitStrings($lang{"seconds"},\$Lang{$L}{"Sabb"}, "lc,sort");
     $Lang{$L}{"Repl"}={};
-    &Date_InitHash($lang{"replace"},undef,"lc",$Lang{$L}{"Repl"});
+    _Date_InitHash($lang{"replace"},undef,"lc",$Lang{$L}{"Repl"});
 
     #  variables for special dates that are offsets from now
@@ -528,11 +537,11 @@
 
     $Lang{$L}{"TimesH"}={};
-    &Date_InitHash($lang{"times"},
+    _Date_InitHash($lang{"times"},
                    \$Lang{$L}{"Times"},"lc,sort,back",
                    $Lang{$L}{"TimesH"});
-    &Date_InitStrings($lang{"now"},\$Lang{$L}{"Now"},"lc,sort");
-    &Date_InitStrings($lang{"today"},\$Lang{$L}{"Today"},"lc,sort");
+    _Date_InitStrings($lang{"now"},\$Lang{$L}{"Now"},"lc,sort");
+    _Date_InitStrings($lang{"today"},\$Lang{$L}{"Today"},"lc,sort");
     $Lang{$L}{"OffsetH"}={};
-    &Date_InitHash($lang{"offset"},
+    _Date_InitHash($lang{"offset"},
                    \$Lang{$L}{"Offset"},"lc,sort,back",
                    $Lang{$L}{"OffsetH"});
@@ -547,126 +556,7 @@
     #    tz2z       = hash of all tzdata timezones to full timezone (EST#EDT)
 
-    $zonesrfc=
-      "idlw   -1200 ".  # International Date Line West
-      "nt     -1100 ".  # Nome
-      "hst    -1000 ".  # Hawaii Standard
-      "cat    -1000 ".  # Central Alaska
-      "ahst   -1000 ".  # Alaska-Hawaii Standard
-      "akst   -0900 ".  # Alaska Standard
-      "yst    -0900 ".  # Yukon Standard
-      "hdt    -0900 ".  # Hawaii Daylight
-      "akdt   -0800 ".  # Alaska Daylight
-      "ydt    -0800 ".  # Yukon Daylight
-      "pst    -0800 ".  # Pacific Standard
-      "pdt    -0700 ".  # Pacific Daylight
-      "mst    -0700 ".  # Mountain Standard
-      "mdt    -0600 ".  # Mountain Daylight
-      "cst    -0600 ".  # Central Standard
-      "cdt    -0500 ".  # Central Daylight
-      "est    -0500 ".  # Eastern Standard
-      "act    -0500 ".  # Brazil, Acre
-      "pet    -0500 ".  # Peruvian time
-      "sat    -0400 ".  # Chile
-      "clt    -0400 ".  # Chile
-      "clst   -0400 ".  # Chile Standard
-      "bot    -0400 ".  # Bolivia
-      "amt    -0400 ".  # Brazil, Amazon
-      "acst   -0400 ".  # Brazil, Acre Daylight
-      "edt    -0400 ".  # Eastern Daylight
-      "ast    -0400 ".  # Atlantic Standard
-      #"nst   -0330 ".  # Newfoundland Standard      nst=North Sumatra    +0630
-      "nft    -0330 ".  # Newfoundland
-      #"gst   -0300 ".  # Greenland Standard         gst=Guam Standard    +1000
-      "cldt   -0300 ".  # Chile Daylight
-      #"bst   -0300 ".  # Brazil Standard            bst=British Summer   +0100
-      "brt    -0300 ".  # Brazil Standard (official time)
-      #"brst   -0300 ".  # Brazil Standard
-      "adt    -0300 ".  # Atlantic Daylight
-      "art    -0300 ".  # Argentina
-      "amst   -0300 ".  # Brazil, Amazon Daylight
-      "uyt    -0300 ".  # Uruguay
-      "ndt    -0230 ".  # Newfoundland Daylight
-      "brst   -0200 ".  # Brazil Daylight (official time)
-      "fnt    -0200 ".  # Brazil, Fernando de Noronha
-      "at     -0200 ".  # Azores
-      "yust   -0200 ".  # Uruguay
-      "wat    -0100 ".  # West Africa
-      "fnst   -0100 ".  # Brazil, Fernando de Noronha Daylight
-      "gmt    +0000 ".  # Greenwich Mean
-      "ut     +0000 ".  # Universal
-      "utc    +0000 ".  # Universal (Coordinated)
-      "wet    +0000 ".  # Western European
-      "cet    +0100 ".  # Central European
-      "fwt    +0100 ".  # French Winter
-      "met    +0100 ".  # Middle European
-      "mez    +0100 ".  # Middle European
-      "mewt   +0100 ".  # Middle European Winter
-      "swt    +0100 ".  # Swedish Winter
-      "bst    +0100 ".  # British Summer             bst=Brazil standard  -0300
-      "gb     +0100 ".  # GMT with daylight savings
-      "west   +0100 ".  # Western European Daylight
-      "eet    +0200 ".  # Eastern Europe, USSR Zone 1
-      "cest   +0200 ".  # Central European Summer
-      "fst    +0200 ".  # French Summer
-      "ist    +0200 ".  # Israel standard
-      "mest   +0200 ".  # Middle European Summer
-      "mesz   +0200 ".  # Middle European Summer
-      "metdst +0200 ".  # An alias for mest used by HP-UX
-      "sast   +0200 ".  # South African Standard
-      "sst    +0200 ".  # Swedish Summer             sst=South Sumatra    +0700
-      "bt     +0300 ".  # Baghdad, USSR Zone 2
-      "eest   +0300 ".  # Eastern Europe Summer
-      "eetdst +0300 ".  # An alias for eest used by HP-UX
-      "eetedt +0300 ".  # Eastern Europe, USSR Zone 1
-      "idt    +0300 ".  # Israel Daylight
-      "msk    +0300 ".  # Moscow
-      "eat    +0300 ".  # East Africa
-      "it     +0330 ".  # Iran
-      "zp4    +0400 ".  # USSR Zone 3
-      "msd    +0400 ".  # Moscow Daylight
-      "zp5    +0500 ".  # USSR Zone 4
-      "ist    +0530 ".  # Indian Standard
-      "zp6    +0600 ".  # USSR Zone 5
-      "novt   +0600 ".  # Novosibirsk winter time zone, Russia
-      "nst    +0630 ".  # North Sumatra              nst=Newfoundland Std -0330
-      #"sst   +0700 ".  # South Sumatra, USSR Zone 6 sst=Swedish Summer   +0200
-      "javt   +0700 ".  # Java
-      "ict    +0700 ".  # Indo China Time
-      "novst  +0700 ".  # Novosibirsk summer time zone, Russia
-      "krat   +0700 ".  # Krasnoyarsk, Russia
-      "myt    +0800 ".  # Malaysia
-      "hkt    +0800 ".  # Hong Kong
-      "sgt    +0800 ".  # Singapore
-      "cct    +0800 ".  # China Coast, USSR Zone 7
-      "krast  +0800 ".  # Krasnoyarsk, Russia Daylight
-      "awst   +0800 ".  # Australian Western Standard
-      "wst    +0800 ".  # West Australian Standard
-      "pht    +0800 ".  # Asia Manila
-      "kst    +0900 ".  # Republic of Korea
-      "jst    +0900 ".  # Japan Standard, USSR Zone 8
-      "rok    +0900 ".  # Republic of Korea
-      "acst   +0930 ".  # Australian Central Standard
-      "cast   +0930 ".  # Central Australian Standard
-      "aest   +1000 ".  # Australian Eastern Standard
-      "east   +1000 ".  # Eastern Australian Standard
-      "gst    +1000 ".  # Guam Standard, USSR Zone 9 gst=Greenland Std    -0300
-      "chst   +1000 ".  # Guam Standard, USSR Zone 9 gst=Greenland Std    -0300
-      "acdt   +1030 ".  # Australian Central Daylight
-      "cadt   +1030 ".  # Central Australian Daylight
-      "aedt   +1100 ".  # Australian Eastern Daylight
-      "eadt   +1100 ".  # Eastern Australian Daylight
-      "idle   +1200 ".  # International Date Line East
-      "nzst   +1200 ".  # New Zealand Standard
-      "nzt    +1200 ".  # New Zealand
-      "nzdt   +1300 ".  # New Zealand Daylight
-      "z +0000 ".
-      "a +0100 b +0200 c +0300 d +0400 e +0500 f +0600 g +0700 h +0800 ".
-      "i +0900 k +1000 l +1100 m +1200 ".
-      "n -0100 o -0200 p -0300 q -0400 r -0500 s -0600 t -0700 u -0800 ".
-      "v -0900 w -1000 x -1100 y -1200";
-
     $Zone{"n2o"} = {};
     ($Zone{"zones"},%{ $Zone{"n2o"} })=
-      &Date_Regexp($zonesrfc,"sort,lc,under,back",
+      _Date_Regexp($Abbrevs,"sort,lc,under,back",
                    "keys");
 
@@ -683,6 +573,6 @@
     $Zone{"tz2z"} = {};
     ($Zone{"tzones"},%{ $Zone{"tz2z"} })=
-      &Date_Regexp($tmp,"lc,under,back","keys");
-    $Cnf{"TZ"}=&Date_TimeZone;
+      _Date_Regexp($tmp,"lc,under,back","keys");
+    $Cnf{"TZ"}=Date_TimeZone();
 
     #  misc. variables
@@ -696,12 +586,12 @@
     #    Prev   = "(?:last|previous)"
 
-    &Date_InitStrings($lang{"at"},    \$Lang{$L}{"At"},     "lc,sort");
-    &Date_InitStrings($lang{"on"},    \$Lang{$L}{"On"},     "lc,sort");
-    &Date_InitStrings($lang{"future"},\$Lang{$L}{"Future"}, "lc,sort");
-    &Date_InitStrings($lang{"later"}, \$Lang{$L}{"Later"},  "lc,sort");
-    &Date_InitStrings($lang{"past"},  \$Lang{$L}{"Past"},   "lc,sort");
-    &Date_InitStrings($lang{"next"},  \$Lang{$L}{"Next"},   "lc,sort");
-    &Date_InitStrings($lang{"prev"},  \$Lang{$L}{"Prev"},   "lc,sort");
-    &Date_InitStrings($lang{"of"},    \$Lang{$L}{"Of"},     "lc,sort");
+    _Date_InitStrings($lang{"at"},    \$Lang{$L}{"At"},     "lc,sort");
+    _Date_InitStrings($lang{"on"},    \$Lang{$L}{"On"},     "lc,sort");
+    _Date_InitStrings($lang{"future"},\$Lang{$L}{"Future"}, "lc,sort");
+    _Date_InitStrings($lang{"later"}, \$Lang{$L}{"Later"},  "lc,sort");
+    _Date_InitStrings($lang{"past"},  \$Lang{$L}{"Past"},   "lc,sort");
+    _Date_InitStrings($lang{"next"},  \$Lang{$L}{"Next"},   "lc,sort");
+    _Date_InitStrings($lang{"prev"},  \$Lang{$L}{"Prev"},   "lc,sort");
+    _Date_InitStrings($lang{"of"},    \$Lang{$L}{"Of"},     "lc,sort");
 
     #  calc mode variables
@@ -710,7 +600,7 @@
     #    Business = "(?:business)"
 
-    &Date_InitStrings($lang{"exact"},   \$Lang{$L}{"Exact"},   "lc,sort");
-    &Date_InitStrings($lang{"approx"},  \$Lang{$L}{"Approx"},  "lc,sort");
-    &Date_InitStrings($lang{"business"},\$Lang{$L}{"Business"},"lc,sort");
+    _Date_InitStrings($lang{"exact"},   \$Lang{$L}{"Exact"},   "lc,sort");
+    _Date_InitStrings($lang{"approx"},  \$Lang{$L}{"Approx"},  "lc,sort");
+    _Date_InitStrings($lang{"business"},\$Lang{$L}{"Business"},"lc,sort");
 
     ############### END OF LANGUAGE INITIALIZATION
@@ -728,8 +618,8 @@
     } else {
       confess "ERROR: Invalid WorkDayBeg in Date::Manip.\n"
-        if (! (($h1,$m1)=&CheckTime($Cnf{"WorkDayBeg"})));
+        if (! (($h1,$m1)=_CheckTime($Cnf{"WorkDayBeg"})));
       $Cnf{"WorkDayBeg"}="$h1:$m1";
       confess "ERROR: Invalid WorkDayEnd in Date::Manip.\n"
-        if (! (($h2,$m2)=&CheckTime($Cnf{"WorkDayEnd"})));
+        if (! (($h2,$m2)=_CheckTime($Cnf{"WorkDayEnd"})));
       $Cnf{"WorkDayEnd"}="$h2:$m2";
 
@@ -759,5 +649,5 @@
     $m++;
   }
-  &Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk);
+  _Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk);
   $Curr{"Y"}=$y;
   $Curr{"M"}=$m;
@@ -767,7 +657,7 @@
   $Curr{"S"}=$s;
   $Curr{"AmPm"}=$ampm;
-  $Curr{"Now"}=&Date_Join($y,$m,$d,$h,$mn,$s);
+  $Curr{"Now"}=_Date_Join($y,$m,$d,$h,$mn,$s);
   if ($Cnf{"TodayIsMidnight"}) {
-    $Curr{"Today"}=&Date_Join($y,$m,$d,0,0,0);
+    $Curr{"Today"}=_Date_Join($y,$m,$d,0,0,0);
   } else {
     $Curr{"Today"}=$Curr{"Now"};
@@ -807,5 +697,5 @@
 
   # We only need to reinitialize if we have to determine what NOW is.
-  &Date_Init()  if (! $Curr{"InitDone"}  or  $Cnf{"UpdateCurrTZ"});
+  Date_Init()  if (! $Curr{"InitDone"}  or  $Cnf{"UpdateCurrTZ"});
 
   my($L)=$Cnf{"Language"};
@@ -849,9 +739,9 @@
 
   $delta="";
-  $delta=&ParseDateDelta($_)  if (/[^:0-9]/);
+  $delta=ParseDateDelta($_)  if (/[^:0-9]/);
 
   # Put parse in a simple loop for an easy exit.
  PARSE: {
-    my(@tmp)=&Date_Split($_);
+    my(@tmp)=_Date_Split($_);
     if (@tmp) {
       ($y,$m,$d,$h,$mn,$s)=@tmp;
@@ -894,16 +784,16 @@
     # Other regular expressions
 
-    my($D4)='(\d{4})';            # 4 digits      (yr)
-    my($YY)='(\d{4}|\d{2})';      # 2 or 4 digits (yr)
-    my($DD)='(\d{2})';            # 2 digits      (mon/day/hr/min/sec)
-    my($D) ='(\d{1,2})';          # 1 or 2 digit  (mon/day/hr)
-    my($FS)="(?:$ss\\d+)?";       # fractional secs
-    my($sep)='[\/.-]';            # non-ISO8601 m/d/yy separators
+    my($D4)='(\d{4})';            	    # 4 digits      (yr)
+    my($YY)='(\d{4}|\d{2})';      	    # 2 or 4 digits (yr)
+    my($DD)='(\d{2})';            	    # 2 digits      (mon/day/hr/min/sec)
+    my($D) ='(\d{1,2})';          	    # 1 or 2 digit  (mon/day/hr)
+    my($FS)="(?:$ss\\d+)?";       	    # fractional secs
+    my($sep)='[\/.-]';            	    # non-ISO8601 m/d/yy separators
     # absolute time zone     +0700 (GMT)
-    my($hzone)='(?:[0-1][0-9]|2[0-3])';                    # 00 - 23
-    my($mzone)='(?:[0-5][0-9])';                           # 00 - 59
+    my($hzone)='(?:[0-1][0-9]|2[0-3])';     # 00 - 23
+    my($mzone)='(?:[0-5][0-9])';            # 00 - 59
     my($zone2)='(?:\s*([+-](?:'."$hzone$mzone|$hzone:$mzone|$hzone))".
-                                                           # +0700 +07:00 -07
-      '(?:\s*\([^)]+\))?)';                                # (GMT)
+                                            # +0700 +07:00 -07
+      '(?:\s*\([^)]+\))?)';                 # (GMT)
 
     # A regular expression for the time EXCEPT for the hour part
@@ -980,5 +870,5 @@
         }
         $time=1;
-        &Date_TimeCheck(\$h,\$mn,\$s,\$ampm);
+        _Date_TimeCheck(\$h,\$mn,\$s,\$ampm);
         $y=$m=$d="";
         # We're going to be calling TimeCheck again below (when we check the
@@ -987,5 +877,5 @@
         $ampm="";
         if (/^\s*$/) {
-          &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+          Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
           last PARSE;
         }
@@ -1070,5 +960,5 @@
         # YY-W##-D
         ($y,$wofm,$dofw)=($1,$2,$3);
-        ($y,$m,$d)=&Date_NthWeekOfYear($y,$wofm,$dofw);
+        ($y,$m,$d)=_Date_NthWeekOfYear($y,$wofm,$dofw);
         last PARSE;
 
@@ -1077,5 +967,5 @@
         # YYDOY
         ($y,$which)=($1,$2);
-        ($y,$m,$d)=&Date_NthDayOfYear($y,$which);
+        ($y,$m,$d)=Date_NthDayOfYear($y,$which);
         last PARSE;
 
@@ -1093,6 +983,6 @@
     return ""  if ($Curr{"InCalc"}  &&  $delta);
     if ($delta) {
-      &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-      return &DateCalc_DateDelta($Curr{"Now"},$delta);
+      Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+      return _DateCalc_DateDelta($Curr{"Now"},$delta);
     }
 
@@ -1110,18 +1000,18 @@
         ($wofm,$dofw,$m,$y)=($1,$2,$3,$4);
         # fix $m, $y
-        return ""  if (&Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk));
+        return ""  if (_Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk));
         $dofw=$week{lc($dofw)};
         $wofm=$wom{lc($wofm)};
         # Get the first day of the month
-        $date=&Date_Join($y,$m,1,$h,$mn,$s);
+        $date=_Date_Join($y,$m,1,$h,$mn,$s);
         if ($wofm==-1) {
-          $date=&DateCalc_DateDelta($date,"+0:1:0:0:0:0:0",\$err,0);
-          $date=&Date_GetPrev($date,$dofw,0);
+          $date=_DateCalc_DateDelta($date,"+0:1:0:0:0:0:0",\$err,0);
+          $date=Date_GetPrev($date,$dofw,0);
         } else {
           for ($i=0; $i<$wofm; $i++) {
             if ($i==0) {
-              $date=&Date_GetNext($date,$dofw,1);
+              $date=Date_GetNext($date,$dofw,1);
             } else {
-              $date=&Date_GetNext($date,$dofw,0);
+              $date=Date_GetNext($date,$dofw,0);
             }
           }
@@ -1132,8 +1022,8 @@
         # last day in month
         ($m,$y)=($1,$2);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $y=&Date_FixYear($y)  if (! defined $y  or  length($y)<4);
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $y=_Date_FixYear($y)  if (! defined $y  or  length($y)<4);
         $m=$month{lc($m)};
-        $d=&Date_DaysInMonth($m,$y);
+        $d=Date_DaysInMonth($m,$y);
         last PARSE;
 
@@ -1141,7 +1031,7 @@
         # friday
         ($dofw)=($1);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&Date_GetPrev($Curr{"Now"},$Cnf{"FirstDay"},1);
-        $date=&Date_GetNext($date,$dofw,1,$h,$mn,$s);
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=Date_GetPrev($Curr{"Now"},$Cnf{"FirstDay"},1);
+        $date=Date_GetNext($date,$dofw,1,$h,$mn,$s);
         last PARSE;
 
@@ -1149,6 +1039,6 @@
         # next friday
         ($dofw)=($1);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&Date_GetNext($Curr{"Now"},$dofw,0,$h,$mn,$s);
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=Date_GetNext($Curr{"Now"},$dofw,0,$h,$mn,$s);
         last PARSE;
 
@@ -1156,32 +1046,32 @@
         # last friday
         ($dofw)=($1);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&Date_GetPrev($Curr{"Now"},$dofw,0,$h,$mn,$s);
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=Date_GetPrev($Curr{"Now"},$dofw,0,$h,$mn,$s);
         last PARSE;
 
       } elsif (/^$next$wkabb$/i) {
         # next week
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{"Now"},"+0:0:1:0:0:0:0",\$err,0);
-        $date=&Date_SetTime($date,$h,$mn,$s)  if (defined $h);
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{"Now"},"+0:0:1:0:0:0:0",\$err,0);
+        $date=Date_SetTime($date,$h,$mn,$s)  if (defined $h);
         last PARSE;
       } elsif (/^$prev$wkabb$/i) {
         # last week
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{"Now"},"-0:0:1:0:0:0:0",\$err,0);
-        $date=&Date_SetTime($date,$h,$mn,$s)  if (defined $h);
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{"Now"},"-0:0:1:0:0:0:0",\$err,0);
+        $date=Date_SetTime($date,$h,$mn,$s)  if (defined $h);
         last PARSE;
 
       } elsif (/^$next$mabb$/i) {
         # next month
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{"Now"},"+0:1:0:0:0:0:0",\$err,0);
-        $date=&Date_SetTime($date,$h,$mn,$s)  if (defined $h);
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{"Now"},"+0:1:0:0:0:0:0",\$err,0);
+        $date=Date_SetTime($date,$h,$mn,$s)  if (defined $h);
         last PARSE;
       } elsif (/^$prev$mabb$/i) {
         # last month
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{"Now"},"-0:1:0:0:0:0:0",\$err,0);
-        $date=&Date_SetTime($date,$h,$mn,$s)  if (defined $h);
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{"Now"},"-0:1:0:0:0:0:0",\$err,0);
+        $date=Date_SetTime($date,$h,$mn,$s)  if (defined $h);
         last PARSE;
 
@@ -1191,16 +1081,16 @@
         # 2 days later
         ($num)=($1);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{"Now"},"+0:0:0:$num:0:0:0",
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{"Now"},"+0:0:0:$num:0:0:0",
                                   \$err,0);
-        $date=&Date_SetTime($date,$h,$mn,$s)  if (defined $h);
+        $date=Date_SetTime($date,$h,$mn,$s)  if (defined $h);
         last PARSE;
       } elsif (/^(\d+)$day$past$/i) {
         # 2 days ago
         ($num)=($1);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{"Now"},"-0:0:0:$num:0:0:0",
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{"Now"},"-0:0:0:$num:0:0:0",
                                  \$err,0);
-        $date=&Date_SetTime($date,$h,$mn,$s)  if (defined $h);
+        $date=Date_SetTime($date,$h,$mn,$s)  if (defined $h);
         last PARSE;
 
@@ -1210,16 +1100,16 @@
         # 2 weeks later
         ($num)=($1);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{"Now"},"+0:0:$num:0:0:0:0",
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{"Now"},"+0:0:$num:0:0:0:0",
                                   \$err,0);
-        $date=&Date_SetTime($date,$h,$mn,$s)  if (defined $h);
+        $date=Date_SetTime($date,$h,$mn,$s)  if (defined $h);
         last PARSE;
       } elsif (/^(\d+)$wkabb$past$/i) {
         # 2 weeks ago
         ($num)=($1);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{"Now"},"-0:0:$num:0:0:0:0",
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{"Now"},"-0:0:$num:0:0:0:0",
                                  \$err,0);
-        $date=&Date_SetTime($date,$h,$mn,$s)  if (defined $h);
+        $date=Date_SetTime($date,$h,$mn,$s)  if (defined $h);
         last PARSE;
 
@@ -1229,16 +1119,16 @@
         # 2 months later
         ($num)=($1);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{"Now"},"+0:$num:0:0:0:0:0",
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{"Now"},"+0:$num:0:0:0:0:0",
                                   \$err,0);
-        $date=&Date_SetTime($date,$h,$mn,$s)  if (defined $h);
+        $date=Date_SetTime($date,$h,$mn,$s)  if (defined $h);
         last PARSE;
       } elsif (/^(\d+)$mabb$past$/i) {
         # 2 months ago
         ($num)=($1);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{"Now"},"-0:$num:0:0:0:0:0",
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{"Now"},"-0:$num:0:0:0:0:0",
                                   \$err,0);
-        $date=&Date_SetTime($date,$h,$mn,$s)  if (defined $h);
+        $date=Date_SetTime($date,$h,$mn,$s)  if (defined $h);
         last PARSE;
 
@@ -1272,19 +1162,19 @@
         # now week     (British date: 1 week from now)
         # today week   (British date: 1 week from today)
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{$tmp},"+0:0:1:0:0:0:0",\$err,0);
-        $date=&Date_SetTime($date,$h,$mn,$s)  if ($time);
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{$tmp},"+0:0:1:0:0:0:0",\$err,0);
+        $date=Date_SetTime($date,$h,$mn,$s)  if ($time);
         last PARSE;
       } elsif (/^$offset\s*$wkabb$/i) {
         # tomorrow week  (British date: 1 week from tomorrow)
         ($offset)=($1);
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
         $offset=$Lang{$L}{"OffsetH"}{lc($offset)};
-        $date=&DateCalc_DateDelta($Curr{"Now"},$offset,\$err,0);
-        $date=&DateCalc_DateDelta($date,"+0:0:1:0:0:0:0",\$err,0);
+        $date=_DateCalc_DateDelta($Curr{"Now"},$offset,\$err,0);
+        $date=_DateCalc_DateDelta($date,"+0:0:1:0:0:0:0",\$err,0);
         if ($time) {
           return ""
-            if (&Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk));
-          $date=&Date_SetTime($date,$h,$mn,$s);
+            if (_Date_DateCheck(\$y,\$m,\$d,\$h,\$mn,\$s,\$ampm,\$wk));
+          $date=Date_SetTime($date,$h,$mn,$s);
         }
         last PARSE;
@@ -1292,9 +1182,9 @@
 
       if ($tmp) {
-        &Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
-        $date=&DateCalc_DateDelta($Curr{"Now"},
+        Date_Init()  if (! $Cnf{"UpdateCurrTZ"});
+        $date=_DateCalc_DateDelta($Curr{"Now"},
                                   $tmp . "0:0:$num:0:0:0:0",\$err,0);
-        $date=&Date_GetPrev($date,$Cnf{"FirstDay"},1);
-        $date=&Date_GetNext($date,$dofw,1,$h,$mn,$s);
+        $date=Date_GetPrev($date,$Cnf{"FirstDay"},1);
+        $date=Date_GetNext($date,$dofw,1,$h,$mn,$s);
         last PARSE;
       }
@@ -1323,9 +1213,9 @@
       $y=$Curr{"Y"}  if (! $y);
       $y--; # previous year
-      $tmp=&Date_GetNext("$y-12-31",$dofw,0);
+      $tmp=Date_GetNext("$y-12-31",$dofw,0);
       if ($which>1) {
-        $tmp=&DateCalc_DateDelta($tmp,"+0:0:".($which-1).":0:0:0:0",\$err,0);
+        $tmp=_DateCalc_DateDelta($tmp,"+0:0:".($which-1).":0:0:0:0",\$err,0);
       }
-      ($y,$m,$d)=(&Date_Split($tmp, 1))[0..2];
+      ($y,$m,$d)=(_Date_Split($tmp, 1))[0..2];
       last PARSE;
     } elsif (/^$week$wkabb\s*$D(?:$of?\s*$YY)?$/i  ||
@@ -1334,5 +1224,5 @@
       # sunday 22nd week in 1996
       ($dofw,$which,$y)=($1,$2,$3);
-      ($y,$m,$d)=&Date_NthWeekOfYear($y,$which,$dofw);
+      ($y,$m,$d)=_Date_NthWeekOfYear($y,$which,$dofw);
       last PARSE;
     }
